unit windos;

//  WINDOS Unit for DELPHI 32 bits
//  Copyright (C) 1998 - Pasquale Morvillo
//  Interface to PASW32.DLL

interface

uses System32, Windows;
{$I WINDOS.INC}
var
     DosError: Integer;

function  DosVersion: Integer;
procedure GetDate(var Year, Month, Day, DayOfWeek: Word);
procedure SetDate(Year, Month, Day: Word);
procedure GetTime(var Hour, Minute, Second, Sec100: Word);
procedure SetTime(Hour, Minute, Second, Sec100: Word);
procedure GetCBreak(var Break: Boolean);
procedure SetCBreak(Break: Boolean);
procedure GetVerify(var Verify: Boolean);
procedure SetVerify(Verify: Boolean);
function  DiskFree(Drive: Byte): Comp;
function  DiskSize(Drive: Byte): Comp;
procedure GetFAttr(var F; var Attr: Word);
procedure SetFAttr(var F; Attr: Word);
procedure GetFTime(var F; var Time: Longint);
procedure SetFTime(var F; Time: Longint);
procedure FindNext(var F: TSearchRec);
procedure UnpackTime(P: Longint; var T: TDateTime);
procedure PackTime(var T: TDateTime; var P: Longint);

procedure FindFirst(Path: PChar; Attr: Word; var F: TSearchRec);
function  FileSearch(Dest, Name, List: PChar): PChar;
function  FileExpand(Dest, Name: PChar): PChar;
function  FileSplit(Path, Dir, Name, Ext: PChar): Word;
function  GetCurDir(Dir: PChar; Drive: Byte): PChar;
procedure SetCurDir(Dir: PChar);
procedure CreateDir(Dir: PChar);
procedure RemoveDir(Dir: PChar);
function  GetArgCount: Integer;
function  GetArgStr(Dest: PChar; Index: Integer; MaxLen: Word): PChar;
function  GetEnvVar(VarName: PChar): PChar;

procedure InitWinDosW32(pDE: pointer);

implementation

function  DosVersion: Integer;
          external DLLname name 'DosVersion';
procedure GetDate(var Year,Month,Day,DayOfWeek: Word);
          external DLLname name 'GetDate';
procedure SetDate(Year,Month,Day: Word);
          external DLLname name 'SetDate';
procedure GetTime(var Hour,Minute,Second,Sec100: Word);
          external DLLname name 'GetTime';
procedure SetTime(Hour,Minute,Second,Sec100: Word);
          external DLLname name 'SetTime';
procedure GetCBreak(var Break: Boolean);
          external DLLname name 'GetCBreak';
procedure SetCBreak(Break: Boolean);
          external DLLname name 'SetCBreak';
procedure GetVerify(var Verify: Boolean);
          external DLLname name 'GetVerify';
procedure SetVerify(Verify: Boolean);
          external DLLname name 'SetVerify';
function  DiskFree(Drive: Byte): Comp;
          external DLLname name 'DiskFree';
function  DiskSize(Drive: Byte): Comp;
          external DLLname name 'DiskSize';
procedure GetFAttr(var F; var Attr: Word);
          external DLLname name 'GetFAttr';
procedure SetFAttr(var F; Attr: Word);
          external DLLname name 'SetFAttr';
procedure GetFTime(var F; var Time: Longint);
          external DLLname name 'GetFTime';
procedure SetFTime(var F; Time: Longint);
          external DLLname name 'SetFTime';
procedure FindNext(var F: TSearchRec);
          external DLLname name 'FindNext';
procedure UnpackTime(P: Longint; var T: TDateTime);
          external DLLname name 'UnpackTime';
procedure PackTime(var T: TDateTime; var P: Longint);
          external DLLname name 'PackTime';

procedure FindFirst(Path: PChar; Attr: Word; var F: TSearchRec);
          external DLLname name '_FindFirst';
function  FileSearch(Dest, Name, List: PChar): PChar;
          external DLLname name '_FileSearch';
function  FileExpand(Dest, Name: PChar): PChar;
          external DLLname name '_FileExpand';
function  FileSplit(Path, Dir, Name, Ext: PChar): Word;
          external DLLname name '_FileSplit';
function  GetCurDir(Dir: PChar; Drive: Byte): PChar;
          external DLLname name '_GetCurDir';
procedure SetCurDir(Dir: PChar);
          external DLLname name '_SetCurDir';
procedure CreateDir(Dir: PChar);
          external DLLname name '_CreateDir';
procedure RemoveDir(Dir: PChar);
          external DLLname name '_RemoveDir';
function  GetArgCount: Integer;
          external DLLname name '_GetArgCount';
function  GetArgStr(Dest: PChar; Index: Integer; MaxLen: Word): PChar;
          external DLLname name '_GetArgStr';
function  GetEnvVar(VarName: PChar): PChar;
          external DLLname name '_GetEnvVar';

procedure InitWinDosW32(pDE: pointer);
          external DLLname name '_InitWinDosW32';

begin
     InitWinDosW32(@DosError);
end.
